


ronPortal.elearning.Otazka = function() {
    this.kodKriteria = '';
    this.poradi = 0;
    this.typRozsahu = '';
    this.popis = '';
    this.upresnujiciPopis = '';
    this.upresnujiciPopisProWeb = '';

    this.zpusobHodnoceni = 0;  // z tabulky ZpusobHodnoceni podle pole typRozsahu
    this.bodovaVaha = 0;
    this.povinnaOdpoved = 0;
    this.volby = [];

    this.spravnaHodnota = 0;
    this.spravnaSlovniOdpoved = '';

    this.vycetSpravnychOdpovedi = [];

    this.nova = false;      // priznak, ze se jedna o novou (jeste neulozenou) otazku
    this.$menuItem = null;  // odkaz na polozku v seznamu stranek
};


ronPortal.elearning.Test = function() {
    this.druhHodnoceni = 0;
    this.temaCislo = 0;

    this.test = 1; // 0=hodnoceni, 1=test
    this.otazky = [];
};

ronPortal.elearning.TestEKurzu = function() {
    this.idRevize = 0;
    this.pocetPokusu = null;
    this.casovyLimit = null;
};

ronPortal.elearning.VolbaTestu = function() {
    this.hodnota = 0;
    this.popis = '';
    this.doplnujiciPopis = '';
    this.koeficient = 0.0;
    this.smazana = 0;
};

ronPortal.elearning.TypOdpovedi = function() {
    this.kod = '';
    this.popis = '';
    this.zpusobHodnoceni = 0;

    this.popisNejnizsiHodnoty = ''; // pro ZPUSOB_ODPOVEDI_STUPNICE
    this.popisNejvyssiHodnoty = '';

    this.zpusobZobrazeni = 0; // 0=pod sebou, 1=vedle sebe
    this.volby = [];
};


ronPortal.elearning.DataTestu = function() {
    this.test = null;
    this.typyOdpovedi = null;
    this.testEKurzu = null;
    this.prilohy = null;
};
ronPortal.elearning.initEditaceTestu = function(dataEditace) {

    let
        aktualniOtazka = -1,
        $nadpis = $("#elearning_nadpis"),
        top = $nadpis.offset().top + $nadpis.outerHeight();

    $("#elearning_container")
        .css("top", top);
    function pridejZalozku(index) {
        let otazka = dataEditace.test.otazky[index];

        otazka.$menuItem = $("<li/>")
            .text(otazka.poradi + '. ' + otazka.kodKriteria)
            .data("ron-poradi", otazka.poradi)
            .data("ron-kod", otazka.kodKriteria)
            .data("ron-index", index)
            .appendTo("#test_obsah_list");

        return otazka.$menuItem;
    }
    function zobrazZalozky(otazky) {
        $("#test_obsah_list").empty();

        for (let i = 0;  i < otazky.length;  i++) {
            pridejZalozku(i);
        }
    }
    $("#elearning_tabs").rontabs({ initialTab: "test_otazka"});

    zobrazZalozky(dataEditace.test.otazky);

    ronPortal.elearning.zobrazPrilohy(dataEditace.prilohy, dataEditace.testEKurzu.idRevize);

    function nactiTypyOdpovedi() {
        let $select = $("#typRozsahu");
        $select.empty();

        for (let i = 0;  i < dataEditace.typyOdpovedi.length;  i++) {
            $("<option/>")
                .val(dataEditace.typyOdpovedi[i].kod)
                .text(dataEditace.typyOdpovedi[i].popis)
                .appendTo($select);
        }
    }

    nactiTypyOdpovedi();

    function vratTypOdpovedi(kod) {
        for (let i = 0;  i < dataEditace.typyOdpovedi.length;  i++) {
            if (dataEditace.typyOdpovedi[i].kod === kod) {
                return dataEditace.typyOdpovedi[i];
            }
        }

        return null;
    }
    function zobrazVolbu(volby, index, readOnly, povolitViceOdpovedi, checked) {
        if (volby[index].smazana) {
            return;
        }

        let $checkInput = $("<input/>")
            .attr("id", "volba_" + index); // volby[index].hodnota);

        if (povolitViceOdpovedi) {
            $checkInput
                .attr("type", "checkbox");
        } else {
            $checkInput
                .attr("type", "radio")
                .attr("name", "spravnaHodnota");
        }

        if (checked) {
            $checkInput
                .attr("checked", "checked");
        }

        let $text =
            $("<textarea/>")
                .addClass("form-input priloha-target")
                .attr("id", "textOdpovedi_" + index)
                .val(volby[index].popis);

        let $hodnota = null;
        if (!readOnly) $hodnota =
            $("<input/>")
                .addClass("form-input")
                .attr("id", "hodnotaOdpovedi_" + index)
                .val(volby[index].hodnota);

        let $koeficient = null;
        if (!readOnly) $koeficient =
            $("<input/>")
                .addClass("form-input")
                .attr("id", "koeficientOdpovedi_" + index)
                .val(volby[index].koeficient);

        if (readOnly) {
            $text.attr("disabled", "disabled");
        }

        let $row = $("<div/>")
            .addClass("row")
            .attr("id", "radekOdpovedi_" + index)
            .append(
                $("<div/>")
                    .attr("class", "col-2 caption")
                    .append( $checkInput )
            )
            .append(
                $("<div/>")
                    .addClass("col-7 padding-right")
                    .append( $text )
            )
            .appendTo( $("#vycetOdpovedi") );
        let $td = $("<div/>").addClass("col-1 padding-right").appendTo($row);
        if ($hodnota) {
            $td.append($hodnota);
        }
        $td = $("<div/>").addClass("col-1 padding-right").appendTo($row);
        if ($koeficient) {
            $td.append($koeficient);
        }

        $td = $("<div/>")
            .addClass("col-1")
            .appendTo( $row );

        if (!readOnly) {
            $("<i/>")
                .addClass("deleteRow")
                .addClass("fa inline-glyph glyph-button glyph-delete")
                .data("ron-index", index)
                .appendTo($td);
        }
    }
    function zobrazVycetOdpovedi(volby, readOnly, povolitViceOdpovedi, spravneOdpovedi) {
        let $tbody = $("#vycetOdpovedi");

        $tbody.empty();
        for (let i = 0;  i < volby.length;  i++ ) {
            zobrazVolbu(volby, i, readOnly, povolitViceOdpovedi, ron.inArray(volby[i].hodnota, spravneOdpovedi));
        }

        $("#vycetOdpovediHeader").css("display", "block");
        $tbody.css("display", "block");
        if (!readOnly) {
            $("#tlacitkaOdpovedi").css("display", "block");
        }
    }
    function pridejVolbu() {
        if (aktualniOtazka < 0  ||  aktualniOtazka >= dataEditace.test.otazky.length) {
            return;
        }

        let otazka = dataEditace.test.otazky[aktualniOtazka];
        if (otazka.zpusobHodnoceni !== 5  &&  otazka.zpusobHodnoceni !== 6) {
            return;
        }

        let novaHodnota = 1;
        for (let i = 0;  i < otazka.volby.length;  i++) {
            if (!otazka.volby[i].smazana  &&  novaHodnota <= otazka.volby[i].hodnota) {
                novaHodnota = otazka.volby[i].hodnota + 1;
            }
        }
        otazka.volby[otazka.volby.length] = {
            hodnota : novaHodnota,
            popis : '',
            doplnujiciPopis : '',
            koeficient : 0.0
        };

        zobrazVolbu(otazka.volby, otazka.volby.length - 1, false, otazka.zpusobHodnoceni === 6, false);
    }
    function odstranVolbu() {
        let $this = $(this);

        ron.confirm(
            ron.translate('Opravdu_smazat_volbu'),
            function() {
                let index = $this.data('ron-index');

                dataEditace.test.otazky[aktualniOtazka].volby[index].smazana = 1;
                $("#radekOdpovedi_" + index).toggleClass("deleted", true);
            }
        );
    }
    function zobrazVycetPreddefinovanychOdpovedi(otazka) {
        let typOdpovedi = vratTypOdpovedi(otazka.typRozsahu);
        if (!typOdpovedi) {
            return;
        }

        zobrazVycetOdpovedi(typOdpovedi.volby, true,
            otazka.zpusobHodnoceni === 1,
            (otazka.zpusobHodnoceni === 1) ? otazka.vycetSpravnychOdpovedi : [otazka.spravnaHodnota]);
    }
    function zobrazEditaciSpravneOdpovedi(otazka, hodnota) {
        let $tbody = $("#spravnaHodnotaBody");
        $("#spravnaHodnota").val( hodnota );

        $tbody.css("display", "block");
    }

    function zobrazEditaciMemoOdpovedi(otazka) {
    }
    function zobrazOdpoved(otazka) {
        $("#editace_otazky").children(".spravneOdpovedi").css("display", "none");
        switch (otazka.zpusobHodnoceni) {
            case 0 :
            case 1 :
                zobrazVycetPreddefinovanychOdpovedi(otazka);
                break;

            case 5 :
            case 6 :
                zobrazVycetOdpovedi(otazka.volby, false,
                    otazka.zpusobHodnoceni === 6,
                    (otazka.zpusobHodnoceni === 6) ? otazka.vycetSpravnychOdpovedi : [otazka.spravnaHodnota] );
                break;

            case 2 : // text
                zobrazEditaciSpravneOdpovedi(otazka, otazka.spravnaSlovniOdpoved);
                break;
            case 4 : // hodnota
                zobrazEditaciSpravneOdpovedi(otazka, otazka.spravnaHodnota);
                break;
            case 8 : // datum
                zobrazEditaciSpravneOdpovedi(otazka, "NENI IMPLEMENTOVANO!");
                break;

            case 7 : // memo
                zobrazEditaciMemoOdpovedi(otazka);
                break;
        }
    }


    function typRozsahuChange() {
        if (aktualniOtazka >= 0) {
            dataEditace.test.otazky[aktualniOtazka].typRozsahu = $("#typRozsahu").val();

            let typOdpovedi = vratTypOdpovedi( dataEditace.test.otazky[aktualniOtazka].typRozsahu );
            if (!typOdpovedi) {
                return;
            }

            dataEditace.test.otazky[aktualniOtazka].zpusobHodnoceni = typOdpovedi.zpusobHodnoceni;
            zobrazOdpoved(dataEditace.test.otazky[aktualniOtazka]);
        }
    }


    function vratVybranouOdpoved(volby) {
        for (let i = 0;  i < volby.length;  i++ ) {
            let $checkInput = $("#volba_" + i);
            if ($checkInput.prop("checked")) {
                return volby[i].hodnota;
            }
        }

        return null;
    }


    function vratVybranouPreddefinovanouOdpoved(otazka) {
        console.log('vratVybranouPreddefinovanouOdpoved');
        let typOdpovedi = vratTypOdpovedi(otazka.typRozsahu);
        if (!typOdpovedi) {
            return;
        }

        return vratVybranouOdpoved(typOdpovedi.volby);
    }


    function vratVybraneOdpovedi(volby) {
        let result = [];

        for (let i = 0;  i < volby.length;  i++ ) {
            let $checkInput = $("#volba_" + i);
            if ($checkInput.prop("checked")) {
                result[result.length] = volby[i].hodnota;
            }
        }

        return result;
    }

    function zapisVybraneOdpovedi(data, odpovedi) {
        for (let i = 0;  i < odpovedi.length;  i++ ) {
            data["vybranaVolba" + i] = odpovedi[i];
        }

        data["pocetVybranych"] = odpovedi.length;
    }
    function zapisSpravneOdpovedi(index, data) {
        let otazka = dataEditace.test.otazky[index];

        switch (otazka.zpusobHodnoceni) {
            case 0 :
                otazka.spravnaHodnota = vratVybranouPreddefinovanouOdpoved(otazka);
                data["spravnaHodnota"] = otazka.spravnaHodnota;
                break;
            case 5 :
                otazka.spravnaHodnota = vratVybranouOdpoved(otazka.volby);
                data["spravnaHodnota"] = otazka.spravnaHodnota;
                break;

            case 6 :
                otazka.vycetSpravnychOdpovedi = vratVybraneOdpovedi(otazka.volby);
                zapisVybraneOdpovedi(data, otazka.vycetSpravnychOdpovedi);
                break;

            case 4 : // hodnota
                otazka.spravnaHodnota = $("#spravnaHodnota").val();
                data["spravnaHodnota"] = otazka.spravnaHodnota;
                break;

            case 2 : // text
            case 8 : // datum
                otazka.spravnaSlovniOdpoved = $("#spravnaHodnota").val();
                data["spravnaHodnota"] = otazka.spravnaSlovniOdpoved;
                break;

            case 7 : // memo
                break;
        }
    }
    function zapisOdpovedi(otazka, data) {
        if (otazka.zpusobHodnoceni !== 5  &&  otazka.zpusobHodnoceni !== 6) {
            return;
        }

        for (let i = 0;  i < otazka.volby.length;  i++ ) {
            if (otazka.volby[i].smazana) {
                data["volbaSmazana" + i] = 1;
            } else {
                otazka.volby[i].popis = $("#textOdpovedi_" + i).val();
                data["popisOdpovedi" + i] = otazka.volby[i].popis;
                otazka.volby[i].hodnota = parseInt( $("#hodnotaOdpovedi_" + i).val() );
                data["hodnotaOdpovedi" + i] = otazka.volby[i].hodnota;
                otazka.volby[i].koeficient = ron.utils.stringToFloat( $("#koeficientOdpovedi_" + i).val() );
                data["koeficientOdpovedi" + i] = otazka.volby[i].koeficient;
            }
        }

        data["pocetOdpovedi"] = otazka.volby.length;
    }
    function ulozOtazku(index, callback) {
        ron.showWorkingInfo( ron._('Probiha_ukladani_dat'));

        let
            kodKriteriaOriginal = dataEditace.test.otazky[index].kodKriteria,
            requestData = {
                druhHodnoceni : dataEditace.test.druhHodnoceni,
                temaCislo : dataEditace.test.temaCislo,
                kodKriteriaOriginal : kodKriteriaOriginal,
                kodKriteria : $("#kodOtazky").val(),
                popis : $("#popisOtazky").val(),
                upresnujiciPopis : $("#upresnujiciPopis").val(),
                bodovaVaha : $("#bodovaVaha").val(),
                povinnaOdpoved : $("#povinnaOdpoved").prop("checked") ? 1 : 0,
                typRozsahu : $("#typRozsahu").val()
            };

        zapisOdpovedi(dataEditace.test.otazky[index], requestData);
        zapisSpravneOdpovedi(index, requestData); // nejdrive musi byt zapsany seznam odpovedi!

        $.ajax( {
            url: '?menuid=testy&action=updateotazka',
            type: "POST",
            data: requestData
        })
            .done( function(resultData) {
                if (resultData.result === "OK") {
                    let otazka = dataEditace.test.otazky[index];

                    otazka.kodKriteria = requestData.kodKriteria;
                    otazka.popis = requestData.popis;
                    otazka.upresnujiciPopis = requestData.upresnujiciPopis;
                    otazka.bodovaVaha = requestData.bodovaVaha;
                    otazka.povinnaOdpoved = requestData.povinnaOdpoved;
                    otazka.typRozsahu = requestData.typRozsahu;
                    otazka.nova = false;

                    if (otazka.$menuItem) {
                        otazka.$menuItem.text(otazka.poradi + '. ' + otazka.kodKriteria)
                    }
                    ron.hideWorkingInfo();

                    if (callback) {
                        callback();
                    }
                } else {
                    ron.hideWorkingInfo();

                    ron.showError(resultData);
                }
            }).fail( function(jqXHR) {
                ron.hideWorkingInfo();
                ron.logAjaxError(jqXHR, "Pri ukladani otazky doslo k chybe!");
            });
    }
    function ulozAktualniOtazku(callback) {
        if (aktualniOtazka >= 0  &&  aktualniOtazka < dataEditace.test.otazky.length) {
            ulozOtazku(aktualniOtazka, callback);
        } else {
            if (callback) {
                callback();
            }
        }
    }
    function zobrazOtazku(index, tabId) {
        if (index < 0  ||  index >= dataEditace.test.otazky.length) {
            return;
        }

        aktualniOtazka = index;

        let
            otazka = dataEditace.test.otazky[index],
            $kod = $("#kodOtazky").val(otazka.kodKriteria),
            $popis = $("#popisOtazky").val(otazka.popis);

        $("#upresnujiciPopis").val(otazka.upresnujiciPopis);
        $("#bodovaVaha").val(otazka.bodovaVaha);
        $("#povinnaOdpoved").prop("checked", !!otazka.povinnaOdpoved);

        $("#typRozsahu")
            .val(otazka.typRozsahu);

        zobrazOdpoved(otazka);

        let $tabs = $("#elearning_tabs");

        if (tabId) {
            $tabs.rontabs("selectPage", tabId);
        } else {
            if (!$tabs.rontabs("getSelectedPageId")  ||  $tabs.rontabs("getSelectedPageId") !== "test_otazka") {
                $tabs.rontabs("selectPage", "test_otazka");
            }
        }

        if ($tabs.rontabs("getSelectedPageId") === "test_otazka") {
            $kod.focus();
        }
    }
    function zobrazZalozku($li, tabId) {
        ulozAktualniOtazku(
            function() {
                $("#test_obsah_list")
                    .children().toggleClass("selected", false);

                $li
                    .toggleClass("selected", true);

                zobrazOtazku( $li.data("ron-index") );
            }
        );
    }


    function otazkaCancel() {
        ron.confirm( ron._('Opravdu_zahodit_zmeny'),
            function() {
                if (aktualniOtazka < 0  ||  aktualniOtazka >= dataEditace.test.otazky.length) {
                    return;
                }

                if (dataEditace.test.otazky[aktualniOtazka].nova) {
                    dataEditace.test.otazky[dataEditace.test.otazky.length - 1].$menuItem.remove();
                    dataEditace.test.otazky.splice(dataEditace.test.otazky.length - 1, 1);
                    zobrazOtazku(dataEditace.test.otazky.length - 1);
                } else {
                    zobrazOtazku(aktualniOtazka);
                }
            });
    }


    function seznamOtazekClick() {
        zobrazZalozku( $(this) );
    }


    function odstranOtazku(index) {
        dataEditace.test.otazky[index].$menuItem.remove();
        dataEditace.test.otazky.splice(index, 1);
        if (aktualniOtazka === index) {
            aktualniOtazka = -1;
        }
    }

    function smazatOtazku() {
        let
            $this = $(this),
            index = $this.data("ron-index"),
            otazka = dataEditace.test.otazky[index];

        ron.confirm( ron._('Opravdu_odstranit_otazku') + ' ' + otazka.kodKriteria + '?',
            function() {
                $.ajax(
                    {
                        url: "?menuid=testy&action=deletequestion",
                        type: "POST",
                        data: {
                            druhHodnoceni : dataEditace.test.druhHodnoceni,
                            temaCislo : dataEditace.test.temaCislo,
                            kodKriteria: otazka.kodKriteria
                        }
                    })
                    .done( function(data) {
                        if (data.result === "OK") {
                            odstranOtazku(index);
                        } else {
                            ron.showError(data);
                        }
                    }).fail( function(jqXHR) {
                        ron.logAjaxError(jqXHR, "Pri mazani otazky doslo k chybe!");
                    });
            });
    }


    function novaOtazka() {
        let otazka = new ronPortal.elearning.Otazka();
        otazka.nova = true;
        otazka.poradi = dataEditace.test.otazky.length
            ? dataEditace.test.otazky[dataEditace.test.otazky.length - 1].poradi + 1
            : 1;

        dataEditace.test.otazky[dataEditace.test.otazky.length] = otazka;

        let $listItem = pridejZalozku(dataEditace.test.otazky.length - 1);

        zobrazZalozku($listItem, "test_otazka");

        $.ajax("?menuid=testy&action=novykodotazky&druhhodnoceni=" + dataEditace.test.druhHodnoceni + "&temacislo=" + dataEditace.test.temaCislo)
            .done( function(resultData) {
                if (resultData.result === "OK") {
                    $("#kodOtazky").val( resultData.kodKriteria );
                }
            });

    }


    function ulozHlavickuTestu() {
        ron.showWorkingInfo( ron._('Probiha_ukladani_dat'));

        $.ajax( {
            url: '?menuid=testy&action=updatetest',
            type: "POST",
            data: {
                druhHodnoceni : dataEditace.test.druhHodnoceni,
                temaCislo : dataEditace.test.temaCislo,
                idRevize : dataEditace.testEKurzu ? dataEditace.testEKurzu.idRevize : null,
                kod: $("#kodTestu").val(),
                popis: $("#popisTestu").val(),
                poznamka: $("#poznamkaTestu").val(),
                minPocetBodu: $("#minPocetBodu").val(),
                maxPocetBodu: $("#maxPocetBodu").val(),
                pocetPokusu : $("#pocetPokusu").val(),
                casovyLimit : $("#casovyLimit").val(),
                sirkaSloupce: $("#sirkaSloupce").val(),
                editovatPoznamku: $("#editovatPoznamku").prop("checked") ? 1 : 0,
                zobrazitOdpovediUspesne : $("#zobrazitOdpovediUspesne").val(),
                zobrazitOdpovediNeuspesne : $("#zobrazitOdpovediNeuspesne").val()
            }
        })
            .done( function(resultData) {
                ron.hideWorkingInfo();

                if (resultData.result === "OK") {

                } else {
                    ron.showError(resultData);
                }
            }).fail( function(jqXHR) {
                ron.hideWorkingInfo();
                ron.logAjaxError(jqXHR, "Pri ukladani hlavicky testu doslo k chybe!");
            });

        return false;
    }
    function vlozitHromadneClick() {
        $("#importOtazek").dialog({
            modal : true,
            resizable: true,
            width: "auto",
            height: "auto"
        });
    }


    function zobrazNahledImportovanychOtazek(otazky) {

        let $nahled = $("#nahledImportuOtazek");
        $nahled.empty();

        for (let i = 0;  i < otazky.length;  i++) {
            console.log(otazky[i]);
            $("<div/>")
                .text(otazky[i].popis)
                .appendTo($nahled);

            let $ul = $("<ul/>")
                .appendTo($nahled);

            for (let k = 0;  k < otazky[i].volby.length;  k++) {
                $("<li/>")
                    .text(otazky[i].volby[k].popis)
                    .appendTo($ul);
            }
        }
    }

    let $request = null;

    function nahledImportuOtazek() {
        if ($request) {
            $request.abort();
        }

        $request = $.ajax( {
            url: '?menuid=testy&action=testimport',
            type: "POST",
            data: {
                text: $("#importOtazekText").val()
            }
        })
            .done( function(resultData) {
                $request = null;

                if (resultData.result === "OK") {
                    zobrazNahledImportovanychOtazek(resultData.otazky);
                } else {
                    ron.showError(resultData);
                }
            }).fail( function(jqXHR) {
                $request = null;
                ron.logAjaxError(jqXHR, "Pri odesilani otazek doslo k chybe!");
            });
    }

    let textImportuTimer = null;

    function textImportuChange() {
        if (textImportuTimer) {
            clearTimeout(textImportuTimer);
        }

        textImportuTimer = setTimeout(nahledImportuOtazek, 2000);
    }



    function doplnImportovaneOtazky(otazky) {
        for (let i = 0;  i < otazky.length;  i++) {
            dataEditace.test.otazky[dataEditace.test.otazky.length] = otazky[i];
            pridejZalozku(dataEditace.test.otazky.length - 1);
        }
    }

    function provedImportOtazek() {
        ron.showWorkingInfo( ron.translate("Importuji_otazky") );

        $.ajax( {
            url: '?menuid=testy&action=importotazek',
            type: "POST",
            data: {
                druhHodnoceni : dataEditace.test.druhHodnoceni,
                temaCislo : dataEditace.test.temaCislo,
                text: $("#importOtazekText").val()
            }
        })
            .done( function(resultData) {
                ron.hideWorkingInfo();

                if (resultData.result === "OK") {
                    $("#importOtazek").dialog("close");
                    $("#importOtazekText").val("");
                    doplnImportovaneOtazky(resultData.otazky);
                } else {
                    ron.showError(resultData);
                }
            }).fail( function(jqXHR) {
                ron.hideWorkingInfo();

                $request = null;
                ron.logAjaxError(jqXHR, "Pri odesilani otazek doslo k chybe!");
            });

    }

    $("#nahledImportuOtazek")
        .on("dblclick", function() { $("#importOtazekText").val("Ano?\nAno\nNe\nAsi\n\nJak to jde?\nJde to\nUjde to\n")} );


    $("#test_obsah_list")
        .on("click", "li", seznamOtazekClick)
        .on("editovat-otazku", "li", function() { zobrazZalozku($(this)); })
        .on("odstranit-otazku", "li", smazatOtazku)
        ;


    let $prilohaTargetFocus = null;

    function onInputFocus() {
        let $this = $(this);

        if ($this.is(".priloha-target")) {
            $prilohaTargetFocus = $this;
        } else {
            $prilohaTargetFocus = null;
        }
    }

    function prilohaDblClick() {
        if (!$prilohaTargetFocus  ||  !$prilohaTargetFocus.length) {
            return;
        }

        let
            text,
            $this = $(this),
            id = $this.data("ron-id"),
            index = $("#kurz_prilohy").children("li").index(this);

        if (!id) {
            return;
        }

        if (dataEditace.prilohy[index]) {
            switch (dataEditace.prilohy[index].type) {
                case "image" :
                    text = '<img src="' + "?menuid=kurzy&%DOWNLOAD%&revize=" + dataEditace.testEKurzu.idRevize + "&priloha=" + id + '">';
                    break;

                case "video" :
                    break;

                default :
                    text =
                        '<a target="_blank" href="' + "?menuid=kurzy&%DOWNLOAD%&revize=" + dataEditace.testEKurzu.idRevize + "&priloha=" + id + '">' +
                        ron._('Stahnout_prilohu') +
                        '</a>';
            }
        }

        if (text) {
            let originalText = $prilohaTargetFocus.val();
            $prilohaTargetFocus.val(
                originalText.substring(0, $prilohaTargetFocus.get(0).selectionStart) +
                text +
                originalText.substring($prilohaTargetFocus.get(0).selectionStart)
            );
        }
    }


    $(document.body)
        .on("click", "#otazka_save", function() { ulozAktualniOtazku(null); })
        .on("click", "#otazka_cancel", otazkaCancel)
        .on("click", "#pridatOdpoved", pridejVolbu)
        .on("click", ".deleteRow", odstranVolbu)
        .on("click", "#test_new_content", novaOtazka)
        .on("change", "#typRozsahu", typRozsahuChange)
        .on("click", "#ulozitHlavickuTestu", ulozHlavickuTestu)
        .on("click", "#hromadnyImportLink", vlozitHromadneClick)
        .on("click", "#btnImportOK", provedImportOtazek)
        .on("change keyup paste", "#importOtazekText", textImportuChange)
        .on("focus", "input", onInputFocus)
        .on("focus", "textarea", onInputFocus);

    $("#kurz_prilohy")
        .on("dblclick", "li", prilohaDblClick);
};
